#include <stdio.h>
#include <stdlib.h>
#include "gmp.h"

void compute_fact_gmp(int n);

void compute_fact_basic_c(int n);
void compute_fact_gmp2(mpz_t *n);
int main()
{
    /*compute_fact_basic_c(100);
    compute_fact_gmp(100);*/

    mpz_t n;
    mpz_init_set_ui(n,3);
    compute_fact_gmp2(&n);
    mpz_clear(n);
    return 0;
}

void compute_fact_gmp(int n){
  int c;
  mpz_t p;
  mpz_init_set_ui(p,1);
  for (c=1; c <= n ; c++) mpz_mul_ui(p,p,c);
  printf ("%d!  =  ", n);
  gmp_printf("%Zd\n",p);
  mpz_clear(p);
}


void compute_fact_gmp2(mpz_t *n){
  mpz_t fact;
  mpz_init_set_ui(fact,1);
  mpz_t p;
  mpz_init_set_ui(p,1);
  while(mpz_cmp (p, *n)<=0){
        mpz_mul(fact,fact,p);
        mpz_add_ui(p, p, 1);
  }
  gmp_printf("%Zd\n",fact);
  mpz_clear(p);
  mpz_clear(fact);
}


void compute_fact_basic_c(int n){
  int c;
  int p = 1;
  for (c=1; c <= n ; c++){
    p = p * c;
  }
  printf("%d! = %d",n,p);
}
