#include <stdio.h>
#include <stdlib.h>
#include "gmp.h"

void compute_fibonacci_basic_c(int n);
void compute_fibonacci_gmp(int n);
int main()
{
    compute_fibonacci_basic_c(100);
    printf("\n\n\n");
    compute_fibonacci_gmp(100);
    return 0;
}


void compute_fibonacci_basic_c(int n){
    int i,fibo,prev1,prev2;
    prev1=0;
    prev2=1;
    printf("Fibonacci Series (n=%d):%d,%d", n, prev1, prev2);
    for(i=2;i<=n;i++){
          fibo=prev1+prev2;
          printf(",%d",fibo);
          prev1=prev2;
          prev2=fibo;
     }
}

void compute_fibonacci_gmp(int n){
    int i;
    mpz_t fibo,prev1,prev2;
    mpz_init(fibo);
    mpz_init_set_ui(prev1,0);
    mpz_init_set_ui(prev2,1);
    gmp_printf("Fibonacci Series (n=%d):%Zd,%Zd", n, prev1, prev2);
    for(i=2;i<=n;i++){
        mpz_add( fibo,prev1,prev2 ) ;
        gmp_printf(",%Zd", fibo);
        mpz_set(prev1,prev2);
        mpz_set(prev2,fibo);
     }
     mpz_clear(fibo);
     mpz_clear(prev1);
     mpz_clear(prev2);
}
